﻿Imports System.Windows.Forms

Public Class ChangePins
    Public g_abPinOrder(32) As Byte        ' This is our global byte reorder array.
    Private Sub ChangePins_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Show all available COM ports.
        Dim rk As RegistryKey = Registry.CurrentUser
        Dim rkDLS As RegistryKey = rk.CreateSubKey("software\DownloadSeqs")
        Dim x As Object

        ' try to restore the pin order that we used last time...
        x = rkDLS.GetValue("ChangePinOrder")
        If x <> Nothing Then
            Dim stFields() As String
            stFields = Split(x.ToString, ",")
            Dim i As Integer
            LBPins.Items.Clear()
            For i = 0 To stFields.Count - 1
                LBPins.Items.Add(stFields(i).ToString)
            Next
            PinNum.Text = ""
        End If
        rkDLS.Close()
        rk.Close()

    End Sub

    Private Sub OK_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OK_Button.Click
        Dim rk As RegistryKey = Registry.CurrentUser
        Dim rkDLS As RegistryKey = rk.CreateSubKey("software\DownloadSeqs")
        Dim st As String = ""
        Dim i As Integer
        For i = 0 To 31
            g_abPinOrder(i) = &HFF     'clear out all of the old settings if any...
        Next
        Try
            If LBPins.Items.Count > 0 Then
                st = LBPins.Items.Item(0).ToString()
                g_abPinOrder(0) = Integer.Parse(LBPins.Items.Item(0).ToString(), Globalization.NumberStyles.Integer)
                For i = 1 To LBPins.Items.Count - 1
                    st = st + "," + LBPins.Items.Item(i).ToString()
                    g_abPinOrder(i) = Integer.Parse(LBPins.Items.Item(i).ToString(), Globalization.NumberStyles.Integer)
                Next
            End If

        Catch ex As Exception
            For i = 0 To 31
                g_abPinOrder(i) = &HFF     'clear out all of the old settings if any...
            Next
        End Try
        rkDLS.SetValue("ChangePinOrder", st)
        rkDLS.Close()
        rk.Close()

        Me.DialogResult = System.Windows.Forms.DialogResult.OK
        Me.Close()
    End Sub

    Private Sub Cancel_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Cancel_Button.Click
        Me.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Me.Close()
    End Sub

  
    Private Sub BtnAdd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnAdd.Click
        Dim stFields() As String
        stFields = Split(PinNum.Text, ";")
        If stFields.Count = 1 Then
            stFields = Split(PinNum.Text, ",")
        End If
        Dim i As Integer

        For i = 0 To stFields.Count - 1
            LBPins.Items.Add(stFields(i).ToString)
        Next
        PinNum.Text = ""
    End Sub

    Private Sub BtnRepl_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnRepl.Click
        Dim stFields() As String
        stFields = Split(PinNum.Text, ";")
        If stFields.Count = 1 Then
            stFields = Split(PinNum.Text, ",")
        End If
        Dim i As Integer
        Dim iRepl As Integer = LBPins.SelectedIndex
        For i = 0 To stFields.Count - 1
            If iRepl < LBPins.Items.Count Then
                LBPins.Items.RemoveAt(iRepl)
                LBPins.Items.Insert(iRepl, stFields(i).ToString)
            Else
                LBPins.Items.Add(stFields(i).ToString)
            End If
            iRepl = iRepl + 1
        Next
        PinNum.Text = ""

    End Sub

    Private Sub LBPins_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LBPins.SelectedIndexChanged
        If LBPins.SelectedIndex <> -1 Then
            PinNum.Text = LBPins.Items(LBPins.SelectedIndex).ToString
            BtnRemove.Enabled = True
            BtnRepl.Enabled = True

        Else
            BtnRemove.Enabled = False
            BtnRepl.Enabled = False
        End If
    End Sub

    Private Sub BtnRemove_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnRemove.Click
        If LBPins.SelectedIndex <> -1 Then
            LBPins.Items.RemoveAt(LBPins.SelectedIndex)
        End If
    End Sub
End Class
